local L = AceLibrary("AceLocale-2.2"):new("ShammySpy")
ShammySpy.Totems = {}

--> Earth Totems <--
ShammySpy.Totems[L["Earthbind Totem"]] = {}
ShammySpy.Totems[L["Earthbind Totem"]].Icon = "Spell_Nature_StrengthOfEarthTotem02";
ShammySpy.Totems[L["Earthbind Totem"]].Time = 45;
ShammySpy.Totems[L["Earthbind Totem"]].Type = "Earth";
ShammySpy.Totems[L["Earthbind Totem"]].Life = 5;

ShammySpy.Totems[L["Stoneskin Totem"]] = {};
ShammySpy.Totems[L["Stoneskin Totem"]].Icon = "Spell_Nature_StoneSkinTotem";
ShammySpy.Totems[L["Stoneskin Totem"]].Time = 120;
ShammySpy.Totems[L["Stoneskin Totem"]].Type = "Earth";
ShammySpy.Totems[L["Stoneskin Totem"]].Life = 5;

ShammySpy.Totems[L["Stoneclaw Totem"]] = {};
ShammySpy.Totems[L["Stoneclaw Totem"]].Icon = "Spell_Nature_StoneClawTotem";
ShammySpy.Totems[L["Stoneclaw Totem"]].Time = 15;
ShammySpy.Totems[L["Stoneclaw Totem"]].Type = "Earth";
ShammySpy.Totems[L["Stoneclaw Totem"]].Life = 5;

ShammySpy.Totems[L["Strength of Earth Totem"]] = {};
ShammySpy.Totems[L["Strength of Earth Totem"]].Icon = "Spell_Nature_EarthBindTotem";
ShammySpy.Totems[L["Strength of Earth Totem"]].Time = 120;
ShammySpy.Totems[L["Strength of Earth Totem"]].Type = "Earth";
ShammySpy.Totems[L["Strength of Earth Totem"]].Life = 5;

ShammySpy.Totems[L["Tremor Totem"]] = {};
ShammySpy.Totems[L["Tremor Totem"]].Icon = "Spell_Nature_TremorTotem";
ShammySpy.Totems[L["Tremor Totem"]].Time = 120;
ShammySpy.Totems[L["Tremor Totem"]].Type = "Earth";
ShammySpy.Totems[L["Tremor Totem"]].Life = 5;

ShammySpy.Totems[L["Earth Elemental Totem"]] = {};
ShammySpy.Totems[L["Earth Elemental Totem"]].Icon = "Spell_Nature_EarthElemental_Totem";
ShammySpy.Totems[L["Earth Elemental Totem"]].Time = 120;
ShammySpy.Totems[L["Earth Elemental Totem"]].Type = "Earth";
ShammySpy.Totems[L["Earth Elemental Totem"]].Life = 3000; --Unknown atm

--> Fire Totems <--
ShammySpy.Totems[L["Flametongue Totem"]] = {};
ShammySpy.Totems[L["Flametongue Totem"]].Icon = "Spell_Nature_GuardianWard";
ShammySpy.Totems[L["Flametongue Totem"]].Time = 120;
ShammySpy.Totems[L["Flametongue Totem"]].Type = "Fire";
ShammySpy.Totems[L["Flametongue Totem"]].Life = 5;

ShammySpy.Totems[L["Fire Nova Totem"]] = {};
ShammySpy.Totems[L["Fire Nova Totem"]].Icon = "Spell_Fire_SealOfFire";
ShammySpy.Totems[L["Fire Nova Totem"]].Time = 5;
ShammySpy.Totems[L["Fire Nova Totem"]].Type = "Fire";
ShammySpy.Totems[L["Fire Nova Totem"]].Life = 5;

ShammySpy.Totems[L["Frost Resistance Totem"]] = {};
ShammySpy.Totems[L["Frost Resistance Totem"]].Icon = "Spell_FrostResistanceTotem_01"; 
ShammySpy.Totems[L["Frost Resistance Totem"]].Time = 120;
ShammySpy.Totems[L["Frost Resistance Totem"]].Type = "Fire";
ShammySpy.Totems[L["Frost Resistance Totem"]].Life = 5;

ShammySpy.Totems[L["Magma Totem"]] = {};
ShammySpy.Totems[L["Magma Totem"]].Icon = "Spell_Fire_SelfDestruct";
ShammySpy.Totems[L["Magma Totem"]].Time = 20;
ShammySpy.Totems[L["Magma Totem"]].Type = "Fire";
ShammySpy.Totems[L["Magma Totem"]].Life = 5;

ShammySpy.Totems[L["Searing Totem"]] = {};
ShammySpy.Totems[L["Searing Totem"]].Icon = "Spell_Fire_SearingTotem";
ShammySpy.Totems[L["Searing Totem"]].Time = 0; -- Depends on rank *sigh*
ShammySpy.Totems[L["Searing Totem"]][L["Rank 1"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 1"]].Time = 30;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 2"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 2"]].Time = 35;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 3"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 3"]].Time = 40;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 4"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 4"]].Time = 45;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 5"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 5"]].Time = 50;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 6"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 6"]].Time = 55;
ShammySpy.Totems[L["Searing Totem"]][L["Rank 7"]] = { };
ShammySpy.Totems[L["Searing Totem"]][L["Rank 7"]].Time = 60;
ShammySpy.Totems[L["Searing Totem"]].Type = "Fire";
ShammySpy.Totems[L["Searing Totem"]].Life = 5;

ShammySpy.Totems[L["Totem of Wrath"]] = {};
ShammySpy.Totems[L["Totem of Wrath"]].Icon = "Spell_Fire_TotemOfWrath";
ShammySpy.Totems[L["Totem of Wrath"]].Time = 120;
ShammySpy.Totems[L["Totem of Wrath"]].Type = "Fire";
ShammySpy.Totems[L["Totem of Wrath"]].Life = 5;

ShammySpy.Totems[L["Fire Elemental Totem"]] = {};
ShammySpy.Totems[L["Fire Elemental Totem"]].Icon = "Spell_Fire_Elemental_Totem";
ShammySpy.Totems[L["Fire Elemental Totem"]].Time = 120;
ShammySpy.Totems[L["Fire Elemental Totem"]].Type = "Fire";
ShammySpy.Totems[L["Fire Elemental Totem"]].Life = 3000; --Unknown atm

--> Water Totems <--
ShammySpy.Totems[L["Disease Cleansing Totem"]] = {};
ShammySpy.Totems[L["Disease Cleansing Totem"]].Icon = "Spell_Nature_DiseaseCleansingTotem";
ShammySpy.Totems[L["Disease Cleansing Totem"]].Time = 120;
ShammySpy.Totems[L["Disease Cleansing Totem"]].Type = "Water";
ShammySpy.Totems[L["Disease Cleansing Totem"]].Life = 5;

ShammySpy.Totems[L["Fire Resistance Totem"]] = {};
ShammySpy.Totems[L["Fire Resistance Totem"]].Icon = "Spell_FireResistanceTotem_01"; 
ShammySpy.Totems[L["Fire Resistance Totem"]].Time = 120;
ShammySpy.Totems[L["Fire Resistance Totem"]].Type = "Water";
ShammySpy.Totems[L["Fire Resistance Totem"]].Life = 5;

ShammySpy.Totems[L["Healing Stream Totem"]] = {} ;
ShammySpy.Totems[L["Healing Stream Totem"]].Icon = "INV_Spear_04";
ShammySpy.Totems[L["Healing Stream Totem"]].Time = 60;
ShammySpy.Totems[L["Healing Stream Totem"]].Type = "Water";
ShammySpy.Totems[L["Healing Stream Totem"]].Life = 5;

ShammySpy.Totems[L["Mana Spring Totem"]] = {};
ShammySpy.Totems[L["Mana Spring Totem"]].Icon = "Spell_Nature_ManaRegenTotem";
ShammySpy.Totems[L["Mana Spring Totem"]].Time = 60;
ShammySpy.Totems[L["Mana Spring Totem"]].Type = "Water";
ShammySpy.Totems[L["Mana Spring Totem"]].Life = 5;

ShammySpy.Totems[L["Mana Tide Totem"]] = {};
ShammySpy.Totems[L["Mana Tide Totem"]].Icon = "Spell_Frost_SummonWaterElemental";
ShammySpy.Totems[L["Mana Tide Totem"]].Time = 12;
ShammySpy.Totems[L["Mana Tide Totem"]].Type = "Water";
ShammySpy.Totems[L["Mana Tide Totem"]].Life = 5;

ShammySpy.Totems[L["Poison Cleansing Totem"]] = {};
ShammySpy.Totems[L["Poison Cleansing Totem"]].Icon = "Spell_Nature_PoisonCleansingTotem";
ShammySpy.Totems[L["Poison Cleansing Totem"]].Time = 120;
ShammySpy.Totems[L["Poison Cleansing Totem"]].Type = "Water";
ShammySpy.Totems[L["Poison Cleansing Totem"]].Life = 5;

ShammySpy.Totems[L["Ancient Mana Spring"]] = {};
ShammySpy.Totems[L["Ancient Mana Spring"]].Icon = "INV_Wand_01";
ShammySpy.Totems[L["Ancient Mana Spring"]].Time = 24;
ShammySpy.Totems[L["Ancient Mana Spring"]].Type = "Water";
ShammySpy.Totems[L["Ancient Mana Spring"]].Life = 5;

--> Air Totems <--
ShammySpy.Totems[L["Grace of Air Totem"]] = {};
ShammySpy.Totems[L["Grace of Air Totem"]].Icon = "Spell_Nature_InvisibilityTotem";
ShammySpy.Totems[L["Grace of Air Totem"]].Time = 120;
ShammySpy.Totems[L["Grace of Air Totem"]].Type = "Air";
ShammySpy.Totems[L["Grace of Air Totem"]].Life = 5;

ShammySpy.Totems[L["Grounding Totem"]] = {};
ShammySpy.Totems[L["Grounding Totem"]].Icon = "Spell_Nature_GroundingTotem";
ShammySpy.Totems[L["Grounding Totem"]].Time = 45;
ShammySpy.Totems[L["Grounding Totem"]].Type = "Air";
ShammySpy.Totems[L["Grounding Totem"]].Life = 5;

ShammySpy.Totems[L["Nature Resistance Totem"]] = {};
ShammySpy.Totems[L["Nature Resistance Totem"]].Icon = "Spell_Nature_NatureResistanceTotem";
ShammySpy.Totems[L["Nature Resistance Totem"]].Time = 120;
ShammySpy.Totems[L["Nature Resistance Totem"]].Type = "Air";
ShammySpy.Totems[L["Nature Resistance Totem"]].Life = 5;

ShammySpy.Totems[L["Sentry Totem"]] = {};
ShammySpy.Totems[L["Sentry Totem"]].Icon = "Spell_Nature_RemoveCurse";
ShammySpy.Totems[L["Sentry Totem"]].Time = 300;
ShammySpy.Totems[L["Sentry Totem"]].Type = "Air";
ShammySpy.Totems[L["Sentry Totem"]].Life = 5;

ShammySpy.Totems[L["Tranquil Air Totem"]] = {};
ShammySpy.Totems[L["Tranquil Air Totem"]].Icon = "Spell_Nature_Brilliance";
ShammySpy.Totems[L["Tranquil Air Totem"]].Time = 120;
ShammySpy.Totems[L["Tranquil Air Totem"]].Type = "Air";
ShammySpy.Totems[L["Tranquil Air Totem"]].Life = 5;

ShammySpy.Totems[L["Windfury Totem"]] = {};
ShammySpy.Totems[L["Windfury Totem"]].Icon = "Spell_Nature_Windfury";
ShammySpy.Totems[L["Windfury Totem"]].Time = 120;
ShammySpy.Totems[L["Windfury Totem"]].Type = "Air";
ShammySpy.Totems[L["Windfury Totem"]].Life = 5;

ShammySpy.Totems[L["Windwall Totem"]] = {};
ShammySpy.Totems[L["Windwall Totem"]].Icon = "Spell_Nature_EarthBind";
ShammySpy.Totems[L["Windwall Totem"]].Time = 120;
ShammySpy.Totems[L["Windwall Totem"]].Type = "Air";
ShammySpy.Totems[L["Windwall Totem"]].Life = 5;

ShammySpy.Totems[L["Wrath of Air Totem"]] = {};
ShammySpy.Totems[L["Wrath of Air Totem"]].Icon = "Spell_Nature_SlowingTotem";
ShammySpy.Totems[L["Wrath of Air Totem"]].Time = 120;
ShammySpy.Totems[L["Wrath of Air Totem"]].Type = "Air";
ShammySpy.Totems[L["Wrath of Air Totem"]].Life = 5;

	--> Special <--
ShammySpy.Totems[L["Enamored Water Spirit"]] = {};
ShammySpy.Totems[L["Enamored Water Spirit"]].Icon = "INV_Wand_01"; -- Trinket totem from Sunken Temple
ShammySpy.Totems[L["Enamored Water Spirit"]].Time = 60;
ShammySpy.Totems[L["Enamored Water Spirit"]].Type = "Water";
ShammySpy.Totems[L["Enamored Water Spirit"]].Life = 5;